checkRequire("Lua_FactionApplyListItem");
Lua_FactionApplyListWindow = class("Lua_FactionApplyListWindow", Lua_SecondSizeWindow);
function Lua_FactionApplyListWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FactionApplyListWindow";
	self.skinName = "FactionApplyListWindow_skin";
	self.titleText = LanUtil.getValue(121012);
end

function Lua_FactionApplyListWindow:buildShowItem()
    self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content,1,Vector4(0, 0, 1080, 400));
	self.dragList:setLocation(0, -16, 0);
	self.dragList:setListCell(Lua_FactionApplyListItem, 57, 1080, 1);

	self.autoAcceptChk:setEnable(DataCenter.factionData.myFactionInfo.leaguePos >= Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER);
	self.autoAcceptChk:addBoxChange(self, self.OnAutoAcceptChange);
	self.cleanAllBtn:addClickFuntion(self, self.oRefuseAllClick);
	self.accpetAllBtn:addClickFuntion(self, self.onAcceptAllClick);

	self:updateAutoAccept();

	self:addLuaEvent("FACTION_AUTO_ACCEPT_STATE_UPDATE", self, self.updateAutoAccept);
	self:addLuaEvent("FACTION_JOIN_APPLY_LIST_UPDATE", self, self.onApplyListUpdate);
	DataCenter.factionData:sJoinApplyList(1);
end

function Lua_FactionApplyListWindow:updateAutoAccept()
	self.autoAcceptChk.seleted = DataCenter.factionData.myFactionInfo.autoAccept == 1 and true or false;
end

function Lua_FactionApplyListWindow:onApplyListUpdate()
	self.dragList:setLuaArrayData(DataCenter.factionData.joinApplyList, false);
	self.autoAcceptChk.seleted = DataCenter.factionData.myFactionInfo.autoAccept == 1;
end

function Lua_FactionApplyListWindow:OnAutoAcceptChange(val)
	if val == true then
		Lua_WindowUtil.openWin("Lua_FactionAutoAcceptWindow",WinParam.ACTION_OPEN);
	else
		local msg = getProtoMsg("Proto10100637");
		msg.auto_accept = 0;
		msg.accept_force = DataCenter.factionData.myFactionInfo.acceptForce;
		sendMsg(10100637,msg);
		DataCenter.factionData.myFactionInfo.autoAccept = 0;
	end
end

function Lua_FactionApplyListWindow:oRefuseAllClick()
	local arr = self:getAllIds();
	if arr:getSize() == 0 then
		return;
	end
	DataCenter.factionData:sRefuseApply(arr);
end

function Lua_FactionApplyListWindow:onAcceptAllClick()
	local arr = self:getAllIds();
	if arr:getSize() == 0 then
		return;
	end
	DataCenter.factionData:sAgreeApply(arr);
end

function Lua_FactionApplyListWindow:getAllIds()
	local alist = DataCenter.factionData.joinApplyList;
	local len = alist:getSize();
	local arr = Array();
	if len == 0 then
		return arr;
	end

	for i = 1, len do
		arr:add(alist[i].roleIndex);
	end
	return arr;
end

function Lua_FactionApplyListWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end