checkRequire("Lua_FactionDefine");
checkRequire("Lua_FactionLevelVo");
checkRequire("Lua_FactionBaseListItem");
Lua_FactionBasePanel = class("Lua_FactionBasePanel",Lua_DisplayObject)
function Lua_FactionBasePanel:ctor(p)
	self:superCall("ctor", p, "FactionBasePanel_skin");
end

function Lua_FactionBasePanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.redDotId = 10501;

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 324, 160));
	self.dragContainer:setLocation(-445, -145, 0);

	self.recordBtn:setParent(self.dragContainer.mainContent.transform);
	self.recordBtn:setEnable(false);
	self.xuanyanItem = Lua_FactionBaseXuanYanItem.new(self.dragContainer);
	self.xuanyanItem:getTheBtnInfo(self.recordBtn.mainContent.transform.localPosition);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 745, 450));
	self.dragList:setLocation(122, -10, 0);
	self.dragList:setListCell(Lua_FactionBaseListItem, 53, 745, 1);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setLayout(70, 70, 4);
	self.rItem:setMaxShow(4);
	self.rItem:setDepth(self.depth + 10);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.8, 0.8);
	self.rItem:setLocation(-260,-295, 0);

	self.editBtn.clickScale = false;
	self.editBtn:addClickFuntion(self, self.onEditClick);
	self.getWagesBtn:addClickFuntion(self, self.onGetWagesClick);
	self.factionLogBtn:addClickFuntion(self, self.onLogClick);

	self:showData();

	self:addLuaEvent("FACTION_MY_FACTION_INFO", self, self.showData);
	self:addLuaEvent("FACTION_FACTION_MEMBER_LIST", self, self.updateMemberList);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);
	DataCenter.factionData:sMyFactionMemberList(1); -- 请求成员列表
end

function Lua_FactionBasePanel:showData()
	if DataCenter.factionData.myFactionInfo ~= nil then
		local myFactionInfo = DataCenter.factionData.myFactionInfo;
		self.factionName.text = myFactionInfo.leagueName;
		self.lordName.text = myFactionInfo.leaderName;
		self.factionLv.text = myFactionInfo.leagueLvl;
		self.memberCount.text = myFactionInfo.leagueCount.."/"..myFactionInfo.maxRole;
		self.factionPowerLv.text = myFactionInfo.factionForce;
		self.factionMoney.text = myFactionInfo.leagueResource.."/"..myFactionInfo.totalResource;
		self.factionScore.text = DataCenter.factionLeagueActUtil:getRankNameByIdx(myFactionInfo.battle_lvl); -- 联赛评级
		
		self.xuanyanItem:setText(myFactionInfo.leagueIntro);
		self.dragContainer:updateChildPos();
		
		self.levelData = Lua_FactionLevelVo.new(myFactionInfo.leagueLvl);
		local posIdx = Lua_FactionDefine.FACTION_POS_LIST_REV:indexOf(myFactionInfo.leaguePos);
		local rewardId = self.levelData.salary[posIdx];		
		self.rItem:setRewardByRewardList(Array(rewardId));
		self.rItem:setClickWin(true);
		
		self.editBtn:setEnable(DataCenter.factionData.myFactionInfo.leaguePos >= Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER);
		self.getWagesBtn:setBtnEnable(myFactionInfo.haveSalary == 1);
		
		self:checkRedDot();
	end
end

function Lua_FactionBasePanel:updateMemberList()
	local mlist = DataCenter.factionData.factionMemberList;
	mlist:sort("posSort", true);
	self.dragList:setLuaArrayData(mlist, false);
end

function Lua_FactionBasePanel:updateRedDot(val)
	if val.evenId ~= self.redDotId then
		return;
	end
	self:checkRedDot();
end

function Lua_FactionBasePanel:checkRedDot()
	local showRed = DataCenter.redDotData:getRedDotStateByEventId(self.redDotId);
	if showRed == true then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", -413, -295, 0, 0);
			self._redDot:setDepth(self.depth + 12);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_FactionBasePanel:onEditClick()
	Lua_WindowUtil.openWin("Lua_FactionNoticeEditWindow");
end

function Lua_FactionBasePanel:onGetWagesClick()
	local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    if bag:getLeftSize() > 0 then
		sendMsg(10100612);
	else
		OperateAlert.show(LanUtil.getValue(110863));
	end
end

function Lua_FactionBasePanel:onLogClick()
	sendMsg(10100621);
	Lua_WindowUtil.openWin("Lua_FactionLogWindow");
end

function Lua_FactionBasePanel:dispose()
	if self.xuanyanItem ~= nil then
		self.xuanyanItem:dispose();
		self.xuanyanItem = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_FactionBaseXuanYanItem = class("Lua_FactionBaseXuanYanItem", Lua_DragContainerItem);
function Lua_FactionBaseXuanYanItem:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);
	dragContainer:addSubContainer(self,true);
end

function Lua_FactionBaseXuanYanItem:buildShowItem()
	self:superCall("buildShowItem");

	self.logTxt = UICreate.createLabel(self.content,"", -162, 80, 324, 160, 24);
	self.logTxt.pivot =  UIWidget.Pivot.TopLeft;
	self.logTxt.spacingY = 10;
	self.logTxt.overflowMethod = UILabel.Overflow.ClampContent;
	self.logTxt:setDepth(5);
end

function Lua_FactionBaseXuanYanItem:setText(val)
	self.logTxt.text = "[85A8BE]"..val.."[-]";
end

function Lua_FactionBaseXuanYanItem:getTheBtnInfo(btn)
	self.btnPosX = btn.x;
	self.btnPosY = btn.y;
end

function Lua_FactionBaseXuanYanItem:onPlayerSoundClick()
	if DataCenter.factionData.myFactionInfo.leaguePos < Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER then
		return;
	end

	local v = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.content.transform:InverseTransformPoint(screenpos);
	if mousePosition.x > self.btnPosX and mousePosition.y < self.btnPosY then
		Lua_WindowUtil.openWin("Lua_FactionNoticeEditWindow");
	end
end

function Lua_FactionBaseXuanYanItem:getHeight()
	return self.logTxt.height;
end

function Lua_FactionBaseXuanYanItem:dispose()
	if self.logTxt ~= nil then
		self.logTxt:dispose();
		self.logTxt = nil;
	end
	self:superCall("dispose");
end