Lua_FactionCreateWindow = class("Lua_FactionCreateWindow",Lua_ThirdSizeWindow)
function Lua_FactionCreateWindow:ctor()
	self:superCall("ctor",true,3500,true,LanUtil.getValue(121019));

	self.w = 600;
	self.h = 412;
	self.winOffsetY = -17;
	self.blackAlpha = 0.1;
	self.isClickClose = false;

	self.windowName = "Lua_FactionCreateWindow";
	self.skinName = "FactionCreateWindow_skin";
end
function Lua_FactionCreateWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.nameMaxLen = 12;
	self.createNeedMoney = getConfig({"league_const","create_money","arr"});
	self.copperIcon:setAltas(Lua_MoneyData.getMoneyIconAtlas(self.createNeedMoney[1]), Lua_MoneyData.getIconSpByMoneyType(self.createNeedMoney[1]));
	self.consumeCopper.text = Lua_CommonUtil.getNumberTrans(self.createNeedMoney[2]);
	self.cancelBtn:setDepth(self.depth+2);
	self.createBtn:setDepth(self.depth+2);
	self.createBtn:addClickFuntion(self,self.onCreateClick);
	self.cancelBtn:addClickFuntion(self,self.onCancelClick);

	self.nameInput.text = "";
	self.nameInput.defaultText = LanUtil.getValue(121001);
end

function Lua_FactionCreateWindow:onCreateClick()
	local factionName = self.nameInput.text;
	if factionName == nil or factionName == "" or factionName == LanUtil.getValue(121001) then
		OperateAlert.show(LanUtil.getValue(121001));
		return;
	end

	local idx = string.find(factionName, " ");
	if idx ~= nil then
		OperateAlert.show(LanUtil.getValue(121083));
		return;
	end

	factionName = string.gsub(factionName, "%s", "");
	if strlen(factionName)>self.nameMaxLen then
		OperateAlert.show(LanUtil.getValue(121002));
		return;
	end
	if LanUtil.isIncludeInvalidWord(factionName) == true then
		OperateAlert.show(LanUtil.getValue(121047));
		return;
	end
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.COPPER_AND_BINDCOPPER, self.createNeedMoney[2], true, false) == false then
		return;
	end
	DataCenter.factionData:sCreateFaction(factionName);
	self:hide();
end
function Lua_FactionCreateWindow:onCancelClick()
	self:hide();
end
function Lua_FactionCreateWindow:dispose()
   self:superCall("dispose");
end
