Lua_FactionDonateEquipCellsItem = class("Lua_FactionDonateEquipCellsItem", Lua_ListCell);
function Lua_FactionDonateEquipCellsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.lastClickIndex = -1;
	self.lastClickTime = 0;

	local cell;
	local perWidth = 100;
	local perHeight = 90;
	local startX = -perWidth * (5 - 1) / 2;
	local startY = perHeight * (3 - 1) / 2;
	self.cells = Array();
	for i = 1, 15 do
		cell = Lua_FactionDonateEquipCell.new(self.content);
		cell.content.name = "cell"..i;
		cell:setDepth(3);
		cell:setLocation(startX + (i - 1) % 5 * perWidth, startY - math.ceil(i / 5 - 1) * perHeight, 0);
		self.cells:add(cell);
	end

	local itemWidth = self.cells[1].toolImg.item_bg.width / 2;
	local itemHeight = self.cells[1].toolImg.item_bg.height / 2;
	self.cellPosX = Array();
	for i = 1, 5 do
		self.cellPosX:add({startX + (i - 1) * perWidth - itemWidth, startX + (i - 1) * perWidth + itemWidth});
	end

	self.cellPosY = Array();
	for i = 1, 3 do
		self.cellPosY:add({startY - (i - 1) * perHeight - itemHeight, startY - (i - 1) * perHeight + itemHeight});
	end
end

function Lua_FactionDonateEquipCellsItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	-- self.startIndex = data.startIndex;

	self.items = data.items;
	-- local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	-- local packSize = bagData.packSize == nil and 15 or bagData.packSize;
	for i = 1, self.cells:getSize() do
		if i <= self.items:getSize() then
			self.cells[i]:setData(self.items[i]);			
		else
			self.cells[i]:setData(nil);
		end
	end
end

function Lua_FactionDonateEquipCellsItem:onPlayerSoundClick()
	local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.content.transform:InverseTransformPoint(screenpos);
	local cx = 0;
	for i = 1, self.cellPosX:getSize() do
		if self.cellPosX[i][1] <= mousePosition.x and self.cellPosX[i][2] >= mousePosition.x then
			cx = i;
			break;
		end
	end
	if cx == 0 then
		return;
	end

	local cy = 0;
	for i = 1, self.cellPosY:getSize() do
		if self.cellPosY[i][1] <= mousePosition.y and self.cellPosY[i][2] >= mousePosition.y then
			cy = i;
			break;
		end
	end
	if cy == 0 then
		return;
	end

	self.clickIndex = cx + (cy - 1) * 5;
	self:onSingleClick();

	-- if self.lastClickIndex ~= self.clickIndex or getTime() - self.lastClickTime > 0.3 then
	-- 	self.lastClickTime = getTime();
	-- 	self.lastClickIndex = self.clickIndex;
	-- 	Lua_CommonUtil.delayCall(0.3, self, self.onSingleClick);
	-- else
	-- 	Lua_CommonUtil.removeTimer(self, self.onSingleClick);
	-- 	self:onDoubleClick();
	-- 	self.lastClickTime = -1;
	-- end
end

function Lua_FactionDonateEquipCellsItem:onSingleClick()
	local totalIndex = self.clickIndex + (self.cellSeqIndex - 1) * 15;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if totalIndex <= bagData.packSize then
		if self.cells[self.clickIndex] ~= nil and self.cells[self.clickIndex].data ~= nil then
			-- Lua_PackUtil.showItemInfo(self.cells[self.clickIndex].data);
			local data = self.cells[self.clickIndex].data;
			local packLeftNum = DataCenter.factionHuntingUtil.storeCapcity - DataCenter.packData:getBagType(Lua_PackData.FACTION_WHARE):getUsedSize();
			local leftNum = packLeftNum - DataCenter.factionData.donateEquipNum;
			if DataCenter.factionData:getDonateEquipState(data.index) == false and leftNum <= 0 then
				OperateAlert.show(LanUtil.getValue(121085));
				return;
			end
			
			DataCenter.factionData:setDonateEquipList(data.index, data.id);
			self.cells[self.clickIndex]:updateSelect();
		end
	end
end

-- function Lua_FactionDonateEquipCellsItem:onDoubleClick()
-- 	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
-- 	local tvo = self.cells[self.clickIndex].data;
-- 	if tvo == nil then
-- 		return;
-- 	end
-- end

function Lua_FactionDonateEquipCellsItem:checkOutBound(showRect)
	for i = 1, self.cells:getSize() do
		if self.cells[i].data ~= nil then
			local rect = Lua_Rectangle.new(self.itemX + self.cells[i].x - 40, self.itemY + self.cells[i].y - 40, 80, 80);
			self.cells[i]:showEffectView(showRect:containeRect(rect));
		end
	end
end

function Lua_FactionDonateEquipCellsItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onSingleClick);
	self:superCall("dispose");
end





























Lua_FactionDonateEquipCell = class("Lua_SelectItem", Lua_DisplayObject);

function Lua_FactionDonateEquipCell:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FactionDonateEquipCell:buildShowItem()
    self:superCall("buildShowItem");

    self.toolImg = Lua_ToolImage.new(self.content);
    self.toolImg.defaultRoundEffect = true;
    self.toolImg:setCanClick(false);
end

function Lua_FactionDonateEquipCell:setData(data)
	self.data = data;

	self.toolImg.data = data;
	self.toolImg:showNewTip(false);
	self.toolImg:showLockSlot(false);

	self:updateSelect();
end

function Lua_FactionDonateEquipCell:showEffectView(val)
	self.toolImg:showRoundEffectView(val);
end

function Lua_FactionDonateEquipCell:updateSelect()
	local isSelect = false;
	if self.data ~= nil then
		isSelect = DataCenter.factionData:getDonateEquipState(self.data.index);
	end

	if isSelect then
		if self.selectIcon == nil then
			self.selectIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xz", 0, 0, 0, 0);
			self.selectIcon:setDepth(10);
		end
		self.selectIcon:setEnable(true);
	else
		if self.selectIcon ~= nil then
			self.selectIcon:setEnable(false);
		end
	end
	self.toolImg:setGray(isSelect);
end