Lua_FactionPlayPanel = class("Lua_FactionPlayPanel",Lua_DisplayObject)
function Lua_FactionPlayPanel:ctor(p)
	self:superCall("ctor", p, "FactionPlayWindow_skin");
end

function Lua_FactionPlayPanel:buildShowItem()
	self:superCall("buildShowItem");

	local playTb = getConfig({"faction_play"});
	local arr = Array();
	for i,v in ipairs(playTb) do
		arr:add(v);
	end
	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1096, 600));
	self.dragList:setListCell(Lua_FactionPlayListItem, 130, 548, 2);
	self.dragList:setLocation(-67, -36, 0);
	self.dragList:setLuaArrayData(arr, false);
end

function Lua_FactionPlayPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_FactionPlayListItem = class("Lua_FactionPlayListItem", Lua_ListCell);
function Lua_FactionPlayListItem:ctor(p)
	self:superCall("ctor", p, "FactionPlayListItem_skin");
end

function Lua_FactionPlayListItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = data.name;
	self.descTxt.text = "[85A8BE]"..data.description;

	if (data.goto_open ~= nil and data.goto_open ~= "") or data.event ~= nil then
		self.gotoBtn:addClickFuntion(self, self.onGotoClick);
	end

	if data.red_dot ~= nil then
		self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);
		local showRed = false;
		for k,v in ipairs(data.red_dot) do
			if DataCenter.redDotData:getRedDotStateByEventId(v) == true then
				showRed = true;
				break;
			end
		end
		self:checkRedDot(showRed);
	end

	if self.icon == nil then
		self.icon = UICreate.createUIAtlasImage(self.content, data.icon_atlas, data.icon_sprite, -197, -1, 0, 0);
		self.icon:setDepth(3);
	end

	local isOpen  = true;
	if data.open_level > DataCenter.roleData.level then
		isOpen = false;
	end

	self.gotoBtn.mouseEnable = isOpen;
	if data.description_second ~= nil then
		self.timesTxt.text = "[85A8BE]"..data.description_second;
	else	
		if isOpen == true then
			local timesStr = "";
			if data.type == 4 then
				local huntData = DataCenter.factionHuntingUtil;
				local maxTime = huntData.huntTimes;
				local curTimes = 0;
				local tcolor = "[00E125]";
				local huntingList = DataCenter.factionHuntingData:huntingList();
				if huntingList ~= nil then
					curTimes = huntingList.openTimes;
				end
				if curTimes>= maxTime then
					tcolor = "[ff3d3d]";
				end
				timesStr = LanUtil.getValue(121062)..tcolor..curTimes.."/"..maxTime.."[-]";
			elseif data.type == 5 then
				local fcurTimes = 70;
				local fmaxTimes = 70;
				local fcolor = "[00E125]";
				local factionTask = nil;
				local taskList = DataCenter.taskData:getListByType(Lua_TaskDefine.LEAGUE);
				if taskList:getSize()>0 then
					factionTask = taskList[1];
					self.finishTips = nil;
				else
					self.finishTips = LanUtil.getValue(121063);
				end
				if factionTask ~= nil then
					fcurTimes = factionTask.routineIndex;
					fmaxTimes = factionTask.routineTotal;
				end
				if taskList:getSize() == 0 then
					fcolor = "[FF1616]";
				end
				timesStr = LanUtil.getValue(121062)..fcolor..fcurTimes.."/"..fmaxTimes.."[-]";
			end
			self.timesTxt.text = timesStr;
		else
			self.timesTxt.text = LanUtil.formateStr(LanUtil.getValue(121061), tostring(data.open_level));
		end
	end
end

function Lua_FactionPlayListItem:updateRedDot(msg)
	local hadEvent = false;
	for k,v in ipairs(self._data.red_dot) do
		if v == msg.evenId then
			hadEvent = true;
			break;
		end
	end

	if hadEvent == false then
		return;
	end
	self:checkRedDot(msg.bShow);
end

function Lua_FactionPlayListItem:checkRedDot(bShow)	
	if bShow then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 245, 0, 0, 0);
			self._redDot:setDepth(self.depth + 5);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_FactionPlayListItem:onGotoClick()
	if self._data ~= nil then
		if self.finishTips ~= nil then
			OperateAlert.show(self.finishTips);
			return;
		end
		if self._data.goto_open ~= nil then
			Lua_WindowUtil.openWin(self._data.goto_open, WinParam.ACTION_OPEN);
		end
		if self._data.event ~= nil then
			Lua_MsgUtil.callFunc(self._data.event);
		end
	end
end