Lua_FactionRankWindow = class("Lua_FactionRankWindow", Lua_SecondSizeWindow);
function Lua_FactionRankWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FactionRankWindow";
	self.skinName = "FactionRankListWindow_skin";
	self.titleText = LanUtil.getValue(121020);
end

function Lua_FactionRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1080, 500));
	self.dragList:setListCell(Lua_FactionRankListItem, 57, 1080, 1);
	self.dragList:setLocation(0, -53, 0);

	self:addLuaEvent("FACTION_SHOWLIST_UPDATE",self,self.onUpdateList)
	DataCenter.factionData:sFactionList(); -- 请求帮派列表
end

function Lua_FactionRankWindow:onUpdateList()
	self.dragList:setLuaArrayData(DataCenter.factionData.showFactionList,false);
end

function Lua_FactionRankWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_FactionRankListItem = class("Lua_FactionRankListItem",Lua_ListCell)
function Lua_FactionRankListItem:ctor(p)
	self:superCall("ctor", p, "FactionRankListItem_skin");
end

function Lua_FactionRankListItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FactionRankListItem:setData(data)
	self._data = data; -- Lua_FactionListVo
	if data == nil then
		return;
	end

	local myLeagueName = DataCenter.factionData.myFactionInfo.leagueName;
	local lvStr = DataCenter.factionLeagueActUtil:getRankNameByIdx(data.battle_lvl);
	if data.leagueName == myLeagueName then
		self.bg:setAltas("factionWindow", "ui_gangs_bg_04");

		self.factionNameTxt.text = LanUtil.formateStr(LanUtil.getValue(121066), tostring(data.leagueName));
		self.forceTxt.text = LanUtil.formateStr(LanUtil.getValue(121066), tostring(data.leagueForce));
		self.leaderNameTxt.text = LanUtil.formateStr(LanUtil.getValue(121066), tostring(data.leagueLeader));
		self.memberCountTxt.text = LanUtil.formateStr(LanUtil.getValue(121066), tostring(data.currentCount));
		self.lvlTxt.text = LanUtil.formateStr(LanUtil.getValue(121066), lvStr); -- 联赛评级
	else
		self.bg:setAltas("factionWindow", "ui_gangs_bg_05");

		self.factionNameTxt.text = LanUtil.formateStr(LanUtil.getValue(121067), tostring(data.leagueName));
		self.forceTxt.text = LanUtil.formateStr(LanUtil.getValue(121067), tostring(data.leagueForce));
		self.leaderNameTxt.text = LanUtil.formateStr(LanUtil.getValue(121067), tostring(data.leagueLeader));
		self.memberCountTxt.text = LanUtil.formateStr(LanUtil.getValue(121067), tostring(data.currentCount));
		self.lvlTxt.text = LanUtil.formateStr(LanUtil.getValue(121067), lvStr); -- 联赛评级
	end

	if data.rankIndex <= 3 then
		self.rankIcon:setAltas("leaderBoard_atlas", "ui_paihang_widget_no" .. data.rankIndex);
	else
		if data.leagueName == myLeagueName then
			self.rankLab.text = LanUtil.formateStr(LanUtil.getValue(121066), tostring(data.rankIndex));
		else
			self.rankLab.text = LanUtil.formateStr(LanUtil.getValue(121067), tostring(data.rankIndex));
		end
	end
	self.rankIcon:setEnable(data.rankIndex <= 3);
	self.rankLab:setEnable(data.rankIndex > 3);
end