Lua_FactionWhareCellsItem = class("Lua_FactionWhareCellsItem", Lua_ListCell);
function Lua_FactionWhareCellsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.isBatchMode = false;
	self.lastClickIndex = -1;
	self.lastClickTime = 0;

	local cell;
	local perWidth = 100;
	local perHeight = 90;
	local startX = -perWidth * (5 - 1) / 2;
	local startY = perHeight * (4 - 1) / 2;
	self.cells = Array();
	for i = 1, 20 do
		cell = Lua_ToolImage.new(self.content);
		cell.content.name = "cell"..i;
		cell.defaultRoundEffect = true;
		cell:setDepth(3);
		cell:setCanClick(false);
		cell:setLocation(startX + (i - 1) % 5 * perWidth, startY - math.ceil(i / 5 - 1) * perHeight, 0);
		self.cells:add(cell);
	end

	local itemWidth = self.cells[1].item_bg.width / 2;
	local itemHeight = self.cells[1].item_bg.height / 2;
	self.cellPosX = Array();
	for i = 1, 5 do
		self.cellPosX:add({startX + (i - 1) * perWidth - itemWidth, startX + (i - 1) * perWidth + itemWidth});
	end

	self.cellPosY = Array();
	for i = 1, 4 do
		self.cellPosY:add({startY - (i - 1) * perHeight - itemHeight, startY - (i - 1) * perHeight + itemHeight});
	end

	self:addLuaEvent("FACTION_WHARE_UPDATE_DESTORY_ITEM", self, self.onUpdateDestoryItem);
	self:addLuaEvent("FACTION_DEPOT_CHANGE_BATCH_MODE", self, self.onBatchModeChange);
end

function Lua_FactionWhareCellsItem:checkOutBound(showRect)
	for i = 1, self.cells:getSize() do
		if self.cells[i].data ~= nil then
			local rect = Lua_Rectangle.new(self.itemX + self.cells[i].x - 40, self.itemY + self.cells[i].y - 40, 80, 80);
			self.cells[i]:showRoundEffectView(showRect:containeRect(rect));
		end
	end
end

function Lua_FactionWhareCellsItem:onBatchModeChange(val)
	-- self.isBatchMode = val;
	if DataCenter.factionData.factionDepotBatchMode == false then
		-- for i = 1, self.cells:getSize() do
		-- 	self.cells[i]:showSelected(false);
		-- end

		local whareData = DataCenter.packData:getBagType(Lua_PackData.FACTION_WHARE);
		if whareData~= nil then
			whareData:clearSaleList();
		end
		self:onUpdateDestoryItem();
	end
end

function Lua_FactionWhareCellsItem:onUpdateDestoryItem()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.FACTION_WHARE);
	local value = bagData:getBagAllData();
	local valueLen = value:getSize();
	local arr = Array();
	for i = 1, valueLen do
		if DataCenter.factionData.isBat == true then
			if DataCenter.factionData.orderType == value[i].rtDesc and DataCenter.factionData.qualityType == -1 then --选择阶数 不选品质
				arr:add(value[i])
			end
			if DataCenter.factionData.orderType == value[i].rtDesc and  DataCenter.factionData.qualityType == value[i].color then -- 都选择
				arr:add(value[i])
			end
			if DataCenter.factionData.orderType == -1 and DataCenter.factionData.qualityType ~= -1 or value[i].rtDesc == "" then
				-- 选择品质 不选阶数
				arr:add(value[i])
			end
			if 	DataCenter.factionData.orderType == -1 and DataCenter.factionData.qualityType == -1 and value[i].rtDesc ~= "" then --都不选择
				arr:add(value[i])
			end
			-- if DataCenter.factionData.orderType == "" then
			-- 	arr:add(value[i])
			-- end
		else -- 非批量处理
			if DataCenter.factionData.career == value[i].career or value[i].career == 0 then
				if DataCenter.factionData.orderType == value[i].rtDesc and DataCenter.factionData.qualityType == -1 or value[i].rtDesc == "" then
					arr:add(value[i]);
				end
				if DataCenter.factionData.orderType == -1 and DataCenter.factionData.qualityType == value[i].color then
					arr:add(value[i]);
				end
				if DataCenter.factionData.orderType == value[i].rtDesc and DataCenter.factionData.qualityType == value[i].color then
					arr:add(value[i]);
				end
				if DataCenter.factionData.orderType == -1 and DataCenter.factionData.qualityType == -1 and value[i].rtDesc ~= "" then
					arr:add(value[i]);
				end
			end

			if DataCenter.factionData.career == -1 and value[i].career ~= 0 then
				if DataCenter.factionData.orderType == -1  and DataCenter.factionData.qualityType == -1 and value[i].rtDesc ~= "" then
					arr:add(value[i])
				end
				if DataCenter.factionData.orderType == value[i].rtDesc and DataCenter.factionData.qualityType == -1
					or DataCenter.factionData.qualityType == 2 then
					arr:add(value[i])
				end
				if DataCenter.factionData.orderType == -1 and DataCenter.factionData.qualityType == value[i].color then
					arr:add(value[i])
				end
				if DataCenter.factionData.orderType == value[i].rtDesc and DataCenter.factionData.qualityType == value[i].color then
					arr:add(value[i])
				end
			end
		end
	end

	local list = {};
	for i = 1, arr:getSize() do
		list[i] = arr[i];
	end
	
	-- local packSize = bagData.packSize == nil and 30 or bagData.packSize;
	-- local whareData = DataCenter.packData:getBagType(Lua_PackData.FACTION_WHARE);
	for i = 1, self.cells:getSize() do
		local curIndex = self.startIndex + i ;
		self.cells[i].curIndex = self.cells[i];

		-- if curIndex >= packSize then--没开锁
		-- 	self.cells[i].data = nil;
		-- 	self.cells[i]:showLockSlot(true);
		-- else
			self.cells[i]:showLockSlot(false);
			local td = list[curIndex]; -- whareData:getItemByIndex(curIndex);
			if td == nil then
				self.cells[i]:showSelected(false);
				list[tostring(curIndex)] = nil;
			else
				if td.color == DataCenter.factionData.qualityType then
					self.cells[i]:showSelected(true);
				else
					self.cells[i]:showSelected(false);
				end	
			end
			-- self.cells[i]:showSelected(true);
			self.cells[i].data = td;
		-- end

		if DataCenter.factionData.isBat == false then
			self.cells[i]:showSelected(false);
		end
	end
end

function Lua_FactionWhareCellsItem:setData(data)
	self.startIndex = data.startIndex;
	self:onUpdateDestoryItem();
end

function Lua_FactionWhareCellsItem:onPlayerSoundClick()
	local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.content.transform:InverseTransformPoint(screenpos);
	local cx = 0;
	for i = 1, self.cellPosX:getSize() do
		if self.cellPosX[i][1] <= mousePosition.x and self.cellPosX[i][2] >= mousePosition.x then
			cx = i;
			break;
		end
	end
	if cx == 0 then
		return;
	end

	local cy = 0;
	for i = 1, self.cellPosY:getSize() do
		if self.cellPosY[i][1] <= mousePosition.y and self.cellPosY[i][2] >= mousePosition.y then
			cy = i;
			break;
		end
	end
	if cy == 0 then
		return;
	end

	self.clickIndex = cx + (cy - 1) * 5;
	if self.isBatchMode == true then
		self:onSingleClick();
	else
		if self.lastClickIndex ~= self.clickIndex or getTime() - self.lastClickTime > 0.05 then
			self.lastClickTime = getTime();
			self.lastClickIndex = self.clickIndex;
			Lua_CommonUtil.delayCall(0.05, self, self.onSingleClick);
		end
	end
end

function Lua_FactionWhareCellsItem:onDoubleClick()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.FACTION_WHARE);
	local tvo = self.cells[self.clickIndex].data;
	if tvo == nil then
		return;
	end
	Lua_PackUtil.toPack(tvo);
end

function Lua_FactionWhareCellsItem:onSingleClick()
	local totalIndex = self.clickIndex + (self.cellSeqIndex - 1) * 20;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.FACTION_WHARE);
	local packSize = bagData.packSize;
	if totalIndex <= packSize then
		if self.cells[self.clickIndex] ~= nil and self.cells[self.clickIndex].data ~= nil then
			if DataCenter.factionData.factionDepotBatchMode == true then
				local whareData = DataCenter.packData:getBagType(Lua_PackData.FACTION_WHARE);
				local cellSelected = self.cells[self.clickIndex].selected;
				local tdata = self.cells[self.clickIndex].data;
				if tdata.type == 1 then --只处理装备
					if cellSelected == true then
						self.cells[self.clickIndex]:showSelected(false);
						whareData.saleDic[tostring(tdata.index)] = nil;
					else
						self.cells[self.clickIndex]:showSelected(true);
						whareData.saleDic[tostring(tdata.index)] = tdata.count;
					end
				end
			else
				Lua_PackUtil.showItemInfo(self.cells[self.clickIndex].data);
			end
		end
	end
end

function Lua_FactionWhareCellsItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onSingleClick);
	self:superCall("dispose");
end