checkRequire("Lua_FactionWhareCellsItem");
checkRequire("Lua_FactionDonateEquipCellsItem");
Lua_FactionWhareItemListContainer = class("Lua_FactionWhareItemListContainer", Lua_DisplayObject);
function Lua_FactionWhareItemListContainer:ctor(p, type, pagePosx, pagePosy, pageLen)
    self.type = type;
    self.pagePosx = pagePosx;
    self.pagePosy = pagePosy;
    self.pageLen = pageLen;
    self:superCall("ctor", p);
end

function Lua_FactionWhareItemListContainer:buildShowItem()
	self:superCall("buildShowItem");

	local pageIcon
	local perWidth = 29;
	self.pageTipList = Array();
	for i = 1, self.pageLen do
		pageIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_b_1", 0, 0, 0, 0);
		pageIcon.name = i;
		pageIcon:setDepth(5);
		pageIcon:setLocation(self.pagePosx - perWidth * self.pageLen / 2 + perWidth * (i - 1) + perWidth / 2, self.pagePosy, 0);
		pageIcon:addClickFuntion(self, self.onPageClick);
		self.pageTipList:add(pageIcon);
	end

	if self.type == Lua_PackData.FACTION_WHARE then
		self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 500, 370));
		self.dragList:setListCell(Lua_FactionWhareCellsItem, 370, 500, 1000);
		self.dragList:setCellScaleChange(true, 1, 1, 500, self, self.onPageCallBack);
		self.dragList:setLocation(26, -10, 0);
	elseif self.type == Lua_PackData.FACTION_DONATE_BAG then
		self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 500, 280));
		self.dragList:setListCell(Lua_FactionDonateEquipCellsItem, 280, 500, 1000);
		self.dragList:setCellScaleChange(true, 1, 1, 500, self, self.onPageCallBack);
	end
	self:updateData();
	self.dragList:moveToIndex(1, true);
end

function Lua_FactionWhareItemListContainer:onPageClick(go)
	self.dragList:moveToIndex(tonumber(go.name));
end

function Lua_FactionWhareItemListContainer:onPageCallBack(val)
	for i = 1, self.pageTipList:getSize() do
		if i == val then
			self.pageTipList[i]:setAltas("common_atlas_1", "ui_common_b_2");
		else
			self.pageTipList[i]:setAltas("common_atlas_1", "ui_common_b_1");
		end
	end
end

function Lua_FactionWhareItemListContainer:updateData()
	if self.type == Lua_PackData.FACTION_WHARE then
		local arr = Array();
		for i = 1, self.pageLen do
			arr:add({page = i, startIndex = (i - 1) * 20});
		end
		self.dragList:setLuaArrayData(arr);
	elseif self.type == Lua_PackData.FACTION_DONATE_BAG then
		local bagItems = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getBagAllData();
		local equList = Array();
		for i = 1, bagItems:getSize() do
			-- 只显示非绑装备，并且有积分的
			if bagItems[i].type == 1 and bagItems[i].bind == 0 and bagItems[i].leagueScore ~= nil and
				bagItems[i].leagueScore > 0 and bagItems[i].star > 0 then
				equList:add(bagItems[i]);
			end
		end

		local equListLen = equList:getSize();
		local tpage = math.ceil(equListLen / 15);
		if tpage == 0 then
			tpage = 1;
		end

		local itemIdx = 1;
		local arr = Array();
		local items;
		for i = 1, tpage do
			items = Array();
			for j = 1, 15 do
				if itemIdx <= equListLen then
					items:add(equList[itemIdx]);
					itemIdx = itemIdx + 1;
				end
			end
			arr:add({page = i, items = items});
		end
		self.dragList:setLuaArrayData(arr);
	else
		local arr = Array();
		for i = 1, self.pageLen do
			arr:add({page = i, startIndex = (i - 1) * 30});
		end
		self.dragList:setLuaArrayData(arr);
	end 
end