-- 社团答题排行榜
Lua_GangAnswarRankWindow = class("Lua_GangAnswarRankWindow", Lua_Window);
function Lua_GangAnswarRankWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GangAnswarRankWindow";
	self.skinName = "GangAnswarRankWindow_skin";
end

function Lua_GangAnswarRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tipstxt.text = LanUtil.getValue(128400);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 878, 360));
	self.dragList:setLocation(0, -24, 0);
	self.dragList:setListCell(Lua_GangRankItem, 72, 878, 1);

	self:setWinData();

	-- self:addLuaEvent("SETGANGRANKINFO", self, self.setWinData);
	-- self:addLuaEvent("AUTO_DESTRUTION_STATE", self, self.initSelectedIndexList);
end

function Lua_GangAnswarRankWindow:setWinData()
	local data = DataCenter.factionData.gangData;
	if data == nil then
		return;
	end

	self.ranktxt.text = LanUtil.formateStr(LanUtil.getValue(128401), tostring(DataCenter.factionData.gangRank));

	local list = Array();
	for i = 1, #data.rank_list do
		list:add({index = data.rank_list[i].rank, name = data.rank_list[i].league_name,
			num = data.rank_list[i].league_score, redNum = data.rank_list[i].league_force});
	end
	self.dragList:setLuaArrayData(list);
end

function Lua_GangAnswarRankWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_GangRankItem = class("Lua_GangRankItem", Lua_ListCell);
function Lua_GangRankItem:ctor(p)
	self:superCall("ctor", p, "GangRankItem_skin");
end

function Lua_GangRankItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GangRankItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.index <= 3 then
		self.rankIcon:setAltas("leaderBoard_atlas", "ui_paihang_widget_no" .. data.index);
	end
	self.rankIcon:setEnable(data.index <= 3);

	self.rankLab.text = data.index;
	self.nameLab.text = data.name;
	self.IntegralLab.text = data.num;
	self.redNumLab.text = data.redNum;
end

function Lua_GangRankItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end